diff --git a/src/main/java/net/minecraft/core/world/generate/MapGenCaves.java b/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java
similarity index 58%
rename from src/main/java/net/minecraft/core/world/generate/MapGenCaves.java
rename to src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java
index d6e237dcb..697fe5fe3 100644
--- a/src/main/java/net/minecraft/core/world/generate/MapGenCaves.java
+++ b/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java
@@ -1,7 +1,5 @@
 package net.minecraft.core.world.generate;
 
-import java.util.Random;
-
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
@@ -12,83 +10,78 @@ import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
 
+import java.util.Random;
+
 // Referenced classes of package net.minecraft.src:
 //            MapGenBase, MathHelper, Block, GrassBlock,
 //            World
 
-public class MapGenCaves extends MapGenBase
-{
+public class CavesLargeFeature extends LargeFeature {
+    private final int minY;
+    private final int maxY;
 
-    public MapGenCaves(boolean isAlpha)
-    {
-        this.isAlpha = isAlpha;
+    public CavesLargeFeature() {
+        minY = 0;
+        maxY = Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
     }
 
-    private boolean isAlpha;
+    public CavesLargeFeature(int minY, int maxY) {
+        this.minY = minY;
+        this.maxY = maxY;
+    }
 
-    protected void generateHubRoom(long seed, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY,
-                                   double blockZ)
-    {
+    protected void generateHubRoom(long seed, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY, double blockZ) {
         generateCave(seed, baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, 1.0F + rand.nextFloat() * 6F, 0.0F, 0.0F, -1, -1, 0.5D);
     }
 
     protected void generateCave(long seed, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY,
-                                double blockZ, float initialRadius, float rotHor, float rotVer, int startPos, int endPos,
-                                double heightMod)
-    {
+                                double blockZ, float initialRadius, float yRot, float xRot, int startPos, int endPos,
+                                double heightMod) {
         double chunkMiddleX = baseChunkX * Chunk.CHUNK_SIZE_X + Chunk.CHUNK_SIZE_X / 2;
         double chunkMiddleZ = baseChunkZ * Chunk.CHUNK_SIZE_Z + Chunk.CHUNK_SIZE_Z / 2;
         float rotHorOffset = 0.0F;
         float rotVerOffset = 0.0F;
         Random random = new Random(seed);
-        if(endPos <= 0)
-        {
+        if (endPos <= 0) {
             int maxLength = radiusChunk * 16 - 16;
             endPos = maxLength - random.nextInt(maxLength / 4);
         }
         boolean noBranches = false;
-        if(startPos == -1)
-        {
+        if (startPos == -1) {
             startPos = endPos / 2;
             noBranches = true;
         }
         int branchPos = random.nextInt(endPos / 2) + endPos / 4;
         boolean sharpRotVer = random.nextInt(6) == 0;
-        for(; startPos < endPos; startPos++)
-        {
+        for (; startPos < endPos; startPos++) {
             double width = 1.5D + (MathHelper.sin((startPos * MathHelper.PI) / endPos) * initialRadius * 1.0F);
             double height = width * heightMod;
-            float xzScale = MathHelper.cos(rotVer);
-            float yOffset = MathHelper.sin(rotVer);
-            blockX += MathHelper.cos(rotHor) * xzScale;
+            float xzScale = MathHelper.cos(xRot);
+            float yOffset = MathHelper.sin(xRot);
+            blockX += MathHelper.cos(yRot) * xzScale;
             blockY += yOffset;
-            blockZ += MathHelper.sin(rotHor) * xzScale;
-            if(sharpRotVer)
-            {
-                rotVer *= 0.92F;
-            }
-            else
-            {
-                rotVer *= 0.7F;
-            }
-            rotVer += rotVerOffset * 0.1F;
-            rotHor += rotHorOffset * 0.1F;
+            blockZ += MathHelper.sin(yRot) * xzScale;
+            if (sharpRotVer) {
+                xRot *= 0.92F;
+            } else {
+                xRot *= 0.7F;
+            }
+            xRot += rotVerOffset * 0.1F;
+            yRot += rotHorOffset * 0.1F;
             rotVerOffset *= 0.9F;
             rotHorOffset *= 0.75F;
             rotVerOffset += (random.nextFloat() - random.nextFloat()) * random.nextFloat() * 2.0F;
             rotHorOffset += (random.nextFloat() - random.nextFloat()) * random.nextFloat() * 4F;
 
             // Do adjacent branches if necessary
-            if(!noBranches && startPos == branchPos && initialRadius > 1.0F)
-            {
-                generateCave(random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, rotHor - MathHelper.PI / 2F, rotVer / 3F, startPos, endPos, 1.0D);
-                generateCave(random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, rotHor + MathHelper.PI / 2F, rotVer / 3F, startPos, endPos, 1.0D);
+            if (!noBranches && startPos == branchPos && initialRadius > 1.0F) {
+                generateCave(random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot - MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
+                generateCave(random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot + MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
                 return;
             }
 
             // Randomly skip a section
-            if(!noBranches && random.nextInt(4) == 0)
-            {
+            if (!noBranches && random.nextInt(4) == 0) {
                 continue;
             }
 
@@ -97,12 +90,10 @@ public class MapGenCaves extends MapGenBase
             double dzFromMiddle = blockZ - chunkMiddleZ;
             double length = endPos - startPos;
             double maxRadius = initialRadius + 2.0F + 16F;
-            if((dxFromMiddle * dxFromMiddle + dzFromMiddle * dzFromMiddle) - length * length > maxRadius * maxRadius)
-            {
+            if ((dxFromMiddle * dxFromMiddle + dzFromMiddle * dzFromMiddle) - length * length > maxRadius * maxRadius) {
                 return;
             }
-            if(blockX < chunkMiddleX - Chunk.CHUNK_SIZE_X - width * 2D || blockZ < chunkMiddleZ - Chunk.CHUNK_SIZE_Z - width * 2D || blockX > chunkMiddleX + Chunk.CHUNK_SIZE_X + width * 2D || blockZ > chunkMiddleZ + Chunk.CHUNK_SIZE_Z + width * 2D)
-            {
+            if (blockX < chunkMiddleX - Chunk.CHUNK_SIZE_X - width * 2D || blockZ < chunkMiddleZ - Chunk.CHUNK_SIZE_Z - width * 2D || blockX > chunkMiddleX + Chunk.CHUNK_SIZE_X + width * 2D || blockZ > chunkMiddleZ + Chunk.CHUNK_SIZE_Z + width * 2D) {
                 continue;
             }
 
@@ -113,104 +104,82 @@ public class MapGenCaves extends MapGenBase
             int maxY = MathHelper.floor(blockY + height) + 1;
             int minZ = MathHelper.floor(blockZ - width) - baseChunkZ * Chunk.CHUNK_SIZE_Z - 1;
             int maxZ = (MathHelper.floor(blockZ + width) - baseChunkZ * Chunk.CHUNK_SIZE_Z) + 1;
-            if(minX < 0)
-            {
+            if (minX < 0) {
                 minX = 0;
             }
-            if(maxX > Chunk.CHUNK_SIZE_X)
-            {
+            if (maxX > Chunk.CHUNK_SIZE_X) {
                 maxX = Chunk.CHUNK_SIZE_X;
             }
-            if(minY < 1)
-            {
-                minY = 1;
+            if (minY < this.minY + 1) {
+                minY = this.minY + 1;
             }
-            if(maxY > (Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y) - (ChunkSection.SECTION_SIZE_Y / 2))
-            {
-                maxY = (Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y) - (ChunkSection.SECTION_SIZE_Y / 2);
+            if (maxY > this.maxY - (ChunkSection.SECTION_SIZE_Y / 2)) {
+                maxY = this.maxY - (ChunkSection.SECTION_SIZE_Y / 2);
             }
-            if(minZ < 0)
-            {
+            if (minZ < 0) {
                 minZ = 0;
             }
-            if(maxZ > Chunk.CHUNK_SIZE_Z)
-            {
+            if (maxZ > Chunk.CHUNK_SIZE_Z) {
                 maxZ = Chunk.CHUNK_SIZE_Z;
             }
 
-            // Check if we've hit water - i.e. the ocean - and if so, stop generating
+            // Check if we've hit the ocean, and if so, stop generating
             boolean hasHitWater = false;
-            for(int x = minX; !hasHitWater && x < maxX; x++)
-            {
-                for(int z = minZ; !hasHitWater && z < maxZ; z++)
-                {
-                    for(int y = maxY + 1; !hasHitWater && y >= minY - 1; y--)
-                    {
+            for (int x = minX; !hasHitWater && x < maxX; x++) {
+                for (int z = minZ; !hasHitWater && z < maxZ; z++) {
+                    for (int y = maxY + 1; !hasHitWater && y >= minY - 1; y--) {
                         int blockId = result.getBlock(x, y, z);
 
-                        if(y < 0 || y >= (Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y))
-                        {
+                        if (y < this.minY || y >= this.maxY) {
                             continue;
                         }
-                        if(Block.hasTag(blockId, BlockTags.IS_WATER))
-                        {
+                        if (Block.hasTag(blockId, BlockTags.IS_WATER)) {
                             hasHitWater = true;
                         }
-                        if(y != minY - 1 && x != minX && x != maxX - 1 && z != minZ && z != maxZ - 1)
-                        {
+                        if (y != minY - 1 && x != minX && x != maxX - 1 && z != minZ && z != maxZ - 1) {
                             y = minY;
                         }
                     }
                 }
             }
-            if(hasHitWater)
-            {
+            if (hasHitWater) {
                 continue;
             }
 
             // Delete blocks in section
-            for(int x = minX; x < maxX; x++)
-            {
+            for (int x = minX; x < maxX; x++) {
                 double xPercentage = (((x + baseChunkX * Chunk.CHUNK_SIZE_X) + 0.5D) - blockX) / width;
-                zLabel: for(int z = minZ; z < maxZ; z++)
-                {
+                zLabel:
+                for (int z = minZ; z < maxZ; z++) {
                     double zPercentage = (((z + baseChunkZ * Chunk.CHUNK_SIZE_Z) + 0.5D) - blockZ) / width;
                     int yIndex = maxY;
                     boolean replaceTopBlock = false;
-                    if(xPercentage * xPercentage + zPercentage * zPercentage >= 1.0D)
-                    {
+                    if (xPercentage * xPercentage + zPercentage * zPercentage >= 1.0D) {
                         continue;
                     }
                     int y = maxY - 1;
-                    do
-                    {
-                        if(y < minY)
-                        {
+                    do {
+                        if (y < minY) {
                             continue zLabel;
                         }
                         double yPercentage = ((y + 0.5D) - blockY) / height;
-                        if(yPercentage > -0.7D && xPercentage * xPercentage + yPercentage * yPercentage + zPercentage * zPercentage < 1.0D)
-                        {
+                        if (yPercentage > -0.7D && xPercentage * xPercentage + yPercentage * yPercentage + zPercentage * zPercentage < 1.0D) {
                             int blockId = result.getBlock(x, yIndex, z);
-                            if(Block.hasTag(blockId, BlockTags.CAVE_GEN_REPLACES_SURFACE))
-                            {
+                            if (Block.hasTag(blockId, BlockTags.CAVE_GEN_REPLACES_SURFACE)) {
                                 replaceTopBlock = true;
                             }
-                            if(Block.hasTag(blockId, BlockTags.CAVES_CUT_THROUGH))
-                            {
-                                if(y < 10)
-                                {
+                            if (Block.hasTag(blockId, BlockTags.CAVES_CUT_THROUGH)) {
+                                if (y < 10) {
                                     result.setBlock(x, yIndex, z, Blocks.FLUID_LAVA_STILL.id);
-                                } else
-                                {
+                                } else {
                                     result.setBlock(x, yIndex, z, 0);
-                                    
-                                    if(replaceTopBlock) {
+
+                                    if (replaceTopBlock) {
                                         Biome biome = worldObj.getBlockBiome(x, yIndex - 1, z);
                                         int topBlockId = biome.topBlock;
                                         int fillBlockId = biome.fillerBlock;
                                         int id = result.getBlock(x, yIndex - 1, z);
-                                    	if(id == fillBlockId) {
+                                        if (id == fillBlockId) {
                                             result.setBlock(x, yIndex - 1, z, topBlockId);
                                         }
                                     }
@@ -219,45 +188,40 @@ public class MapGenCaves extends MapGenBase
                         }
                         yIndex--;
                         y--;
-                    } while(true);
+                    } while (true);
                 }
-
             }
 
-            if(noBranches)
-            {
+            if (noBranches) {
                 break;
             }
         }
-
     }
 
     @Override
-	protected void doGeneration(World world, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result)
-    {
+    protected void doGeneration(World world, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result) {
         int cavesToGenerate = rand.nextInt(rand.nextInt(rand.nextInt(40) + 1) + 1);
-        if(rand.nextInt(15) != 0)
-        {
+        if (rand.nextInt(15) != 0) {
             cavesToGenerate = 0;
         }
-        for(int i = 0; i < cavesToGenerate; i++)
-        {
+
+        final int yRange = maxY - minY;
+
+        for (int i = 0; i < cavesToGenerate; i++) {
             double blockX = chunkX * Chunk.CHUNK_SIZE_X + rand.nextInt(Chunk.CHUNK_SIZE_X);
-            double blockY = rand.nextInt(rand.nextInt((Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y) - 8) + 8);
+            double blockY = minY + rand.nextInt(rand.nextInt(yRange - (ChunkSection.SECTION_SIZE_Y / 2)) + (ChunkSection.SECTION_SIZE_Y / 2));
             double blockZ = chunkZ * Chunk.CHUNK_SIZE_Z + rand.nextInt(Chunk.CHUNK_SIZE_Z);
 
             int numBranches = 1;
-            if(rand.nextInt(4) == 0)
-            {
+            if (rand.nextInt(4) == 0) {
                 generateHubRoom(rand.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ);
                 numBranches += rand.nextInt(4);
             }
-            for(int l1 = 0; l1 < numBranches; l1++)
-            {
-                float f = rand.nextFloat() * MathHelper.PI * 2.0F; // 0 - 2Pi
-                float f1 = ((rand.nextFloat() - 0.5F) * 2.0F) / 8F; // -0.125 - 0.125
+            for (int l1 = 0; l1 < numBranches; l1++) {
+                float yRot = rand.nextFloat() * MathHelper.PI * 2.0F; // 0 - 2Pi
+                float xRot = ((rand.nextFloat() - 0.5F) * 2.0F) / 8F; // -0.125 - 0.125
                 float initialRadius = rand.nextFloat() * 2.0F + rand.nextFloat(); // 0 - 3
-                generateCave(rand.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, initialRadius, f, f1, 0, 0, 1.0f);
+                generateCave(rand.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, initialRadius, yRot, xRot, 0, 0, 1.0f);
             }
         }
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/MapGenBase.java b/src/main/java/net/minecraft/core/world/generate/LargeFeature.java
similarity index 92%
rename from src/main/java/net/minecraft/core/world/generate/MapGenBase.java
rename to src/main/java/net/minecraft/core/world/generate/LargeFeature.java
index da9e31a53..82ca00f02 100644
--- a/src/main/java/net/minecraft/core/world/generate/MapGenBase.java
+++ b/src/main/java/net/minecraft/core/world/generate/LargeFeature.java
@@ -1,46 +1,45 @@
-package net.minecraft.core.world.generate;
-
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
-import net.minecraft.core.world.World;
-import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
-
-import java.util.Random;
-
-// Referenced classes of package net.minecraft.src:
-//            World, IChunkProvider
-
-public class MapGenBase
-{
-
-    public MapGenBase()
-    {
-        radiusChunk = 8;
-    }
-
-    public void generate(World world, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result)
-    {
-        int radius = radiusChunk;
-        rand.setSeed(world.getRandomSeed());
-        worldObj = world;
-        long randX = (rand.nextLong() / 2L) * 2L + 1L;
-        long randZ = (rand.nextLong() / 2L) * 2L + 1L;
-        for(int chunkX = baseChunkX - radius; chunkX <= baseChunkX + radius; chunkX++)
-        {
-            for(int chunkZ = baseChunkZ - radius; chunkZ <= baseChunkZ + radius; chunkZ++)
-            {
-                rand.setSeed((long)chunkX * randX + (long)chunkZ * randZ ^ world.getRandomSeed());
-                doGeneration(world, chunkX, chunkZ, baseChunkX, baseChunkZ, result);
-            }
-
-        }
-
-    }
-
-    protected void doGeneration(World world, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result)
-    {
-    }
-
-    protected int radiusChunk;
-    protected static Random rand = new Random();
-    protected World worldObj;
+package net.minecraft.core.world.generate;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+
+import java.util.Random;
+
+// Referenced classes of package net.minecraft.src:
+//            World, IChunkProvider
+
+public class LargeFeature
+{
+
+    public LargeFeature()
+    {
+        radiusChunk = 8;
+    }
+
+    public void generate(World world, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result)
+    {
+        int radius = radiusChunk;
+        rand.setSeed(world.getRandomSeed());
+        worldObj = world;
+        long randX = (rand.nextLong() / 2L) * 2L + 1L;
+        long randZ = (rand.nextLong() / 2L) * 2L + 1L;
+        for(int chunkX = baseChunkX - radius; chunkX <= baseChunkX + radius; chunkX++)
+        {
+            for(int chunkZ = baseChunkZ - radius; chunkZ <= baseChunkZ + radius; chunkZ++)
+            {
+                rand.setSeed((long)chunkX * randX + (long)chunkZ * randZ ^ world.getRandomSeed());
+                doGeneration(world, chunkX, chunkZ, baseChunkX, baseChunkZ, result);
+            }
+
+        }
+
+    }
+
+    protected void doGeneration(World world, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result)
+    {
+    }
+
+    protected int radiusChunk;
+    protected static Random rand = new Random();
+    protected World worldObj;
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/world/generate/WarrensCavesLargeFeature.java b/src/main/java/net/minecraft/core/world/generate/WarrensCavesLargeFeature.java
new file mode 100644
index 000000000..5fb6aa9c6
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/WarrensCavesLargeFeature.java
@@ -0,0 +1,228 @@
+package net.minecraft.core.world.generate;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.chunk.ChunkSection;
+import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+
+import java.util.Random;
+
+// Referenced classes of package net.minecraft.src:
+//            MapGenBase, MathHelper, Block, GrassBlock,
+//            World
+
+public class WarrensCavesLargeFeature extends LargeFeature {
+    private final int minY;
+    private final int maxY;
+
+    public WarrensCavesLargeFeature() {
+        minY = 0;
+        maxY = Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
+    }
+
+    public WarrensCavesLargeFeature(int minY, int maxY) {
+        this.minY = minY;
+        this.maxY = maxY;
+    }
+
+    protected void generateHubRoom(long seed, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY, double blockZ) {
+        generateCave(seed, baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, 1.0F + rand.nextFloat() * 6F, 0.0F, 0.0F, -1, -1, 0.5D);
+    }
+
+    protected void generateCave(long seed, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result, double blockX, double blockY,
+                                double blockZ, float initialRadius, float yRot, float xRot, int startPos, int endPos,
+                                double heightMod) {
+        double chunkMiddleX = baseChunkX * Chunk.CHUNK_SIZE_X + Chunk.CHUNK_SIZE_X / 2;
+        double chunkMiddleZ = baseChunkZ * Chunk.CHUNK_SIZE_Z + Chunk.CHUNK_SIZE_Z / 2;
+        float rotHorOffset = 0.0F;
+        float rotVerOffset = 0.0F;
+        Random random = new Random(seed);
+        if (endPos <= 0) {
+            int maxLength = radiusChunk * 24 - 16;
+            endPos = maxLength - random.nextInt(maxLength / 8);
+        }
+        final boolean noRotate = random.nextInt(32) == 0;
+        if (noRotate) {
+            yRot = (yRot / (MathHelper.PI * 2)) * 4;
+            yRot = Math.round(yRot);
+            yRot = yRot * (MathHelper.PI * 2) / 4;
+//            xRot = (xRot / (MathHelper.PI * 2)) * 4;
+//            xRot = Math.round(xRot);
+//            xRot = xRot * (MathHelper.PI * 2) / 4;
+        }
+        int branchPos = random.nextInt(endPos / 2) + endPos / 4;
+        boolean sharpRotVer = random.nextInt(6) == 0;
+        for (; startPos < endPos; startPos++) {
+            double width = 1.5D + (MathHelper.sin((startPos * MathHelper.PI) / endPos) * initialRadius * 1.0F);
+            double height = width * heightMod;
+            float xzScale = MathHelper.cos(xRot);
+            float yOffset = MathHelper.sin(xRot);
+            blockX += MathHelper.cos(yRot) * xzScale;
+            blockY += yOffset;
+            blockZ += MathHelper.sin(yRot) * xzScale;
+
+            if (!noRotate) {
+                if (sharpRotVer) {
+                    xRot *= 0.92F;
+                } else {
+                    xRot *= 0.7F;
+                }
+                xRot += rotVerOffset * 0.1F;
+                yRot += rotHorOffset * 0.1F;
+                rotVerOffset *= 0.9F;
+                rotHorOffset *= 0.75F;
+                rotVerOffset += (random.nextFloat() - random.nextFloat()) * random.nextFloat() * 2.0F;
+                rotHorOffset += (random.nextFloat() - random.nextFloat()) * random.nextFloat() * 4F;
+
+                final int flip = random.nextInt(5);
+                if (flip == 0) {
+                    yRot = -yRot;
+                }
+//                } else if (flip == 1) {
+//                    xRot = -xRot;
+//                }
+                final int addRandom = random.nextInt(4);
+                if (addRandom == 0) {
+                    yRot += random.nextFloat() * MathHelper.PI - MathHelper.PI / 2;
+                }
+//                } else if (addRandom == 1) {
+//                    xRot += random.nextFloat() * MathHelper.PI - MathHelper.PI / 2;
+//                }
+            }
+
+            // Do adjacent branches if necessary
+            if (startPos == branchPos && initialRadius > 1.0F) {
+                generateCave(random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot - MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
+                generateCave(random.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, random.nextFloat() * 0.5F + 0.5F, yRot + MathHelper.PI / 2F, xRot / 3F, startPos, endPos, 1.0D);
+                return;
+            }
+
+            // Randomly skip a section
+            if (random.nextInt(4) == 0) {
+                continue;
+            }
+
+            // Check if we've gone far enough, and stop if so
+            double dxFromMiddle = blockX - chunkMiddleX;
+            double dzFromMiddle = blockZ - chunkMiddleZ;
+            double length = endPos - startPos;
+            double maxRadius = initialRadius + 2.0F + 16F;
+            if ((dxFromMiddle * dxFromMiddle + dzFromMiddle * dzFromMiddle) - length * length > maxRadius * maxRadius) {
+                return;
+            }
+            if (blockX < chunkMiddleX - Chunk.CHUNK_SIZE_X - width * 2D || blockZ < chunkMiddleZ - Chunk.CHUNK_SIZE_Z - width * 2D || blockX > chunkMiddleX + Chunk.CHUNK_SIZE_X + width * 2D || blockZ > chunkMiddleZ + Chunk.CHUNK_SIZE_Z + width * 2D) {
+                continue;
+            }
+
+            // Determine sizes of current section
+            int minX = MathHelper.floor(blockX - width) - baseChunkX * Chunk.CHUNK_SIZE_X - 1;
+            int maxX = (MathHelper.floor(blockX + width) - baseChunkX * Chunk.CHUNK_SIZE_X) + 1;
+            int minY = MathHelper.floor(blockY - height) - 1;
+            int maxY = MathHelper.floor(blockY + height) + 1;
+            int minZ = MathHelper.floor(blockZ - width) - baseChunkZ * Chunk.CHUNK_SIZE_Z - 1;
+            int maxZ = (MathHelper.floor(blockZ + width) - baseChunkZ * Chunk.CHUNK_SIZE_Z) + 1;
+            if (minX < 0) {
+                minX = 0;
+            }
+            if (maxX > Chunk.CHUNK_SIZE_X) {
+                maxX = Chunk.CHUNK_SIZE_X;
+            }
+            if (minY < this.minY + 1) {
+                minY = this.minY + 1;
+            }
+            if (maxY > this.maxY - (ChunkSection.SECTION_SIZE_Y / 2)) {
+                maxY = this.maxY - (ChunkSection.SECTION_SIZE_Y / 2);
+            }
+            if (minZ < 0) {
+                minZ = 0;
+            }
+            if (maxZ > Chunk.CHUNK_SIZE_Z) {
+                maxZ = Chunk.CHUNK_SIZE_Z;
+            }
+
+            // Check if we've hit the ocean, and if so, stop generating
+            boolean hasHitWater = false;
+            for (int x = minX; !hasHitWater && x < maxX; x++) {
+                for (int z = minZ; !hasHitWater && z < maxZ; z++) {
+                    for (int y = maxY + 1; !hasHitWater && y >= minY - 1; y--) {
+                        int blockId = result.getBlock(x, y, z);
+
+                        if (y < this.minY || y >= this.maxY) {
+                            continue;
+                        }
+                        if (Block.hasTag(blockId, BlockTags.IS_WATER)) {
+                            hasHitWater = true;
+                        }
+                        if (y != minY - 1 && x != minX && x != maxX - 1 && z != minZ && z != maxZ - 1) {
+                            y = minY;
+                        }
+                    }
+                }
+            }
+            if (hasHitWater) {
+                continue;
+            }
+
+            // Delete blocks in section
+            for (int x = minX; x < maxX; x++) {
+                double xPercentage = (((x + baseChunkX * Chunk.CHUNK_SIZE_X) + 0.5D) - blockX) / width;
+                zLabel:
+                for (int z = minZ; z < maxZ; z++) {
+                    double zPercentage = (((z + baseChunkZ * Chunk.CHUNK_SIZE_Z) + 0.5D) - blockZ) / width;
+                    int yIndex = maxY;
+                    if (xPercentage * xPercentage + zPercentage * zPercentage >= 1.0D) {
+                        continue;
+                    }
+                    int y = maxY - 1;
+                    do {
+                        if (y < minY) {
+                            continue zLabel;
+                        }
+                        double yPercentage = ((y + 0.5D) - blockY) / height;
+                        if (yPercentage > -0.7D && xPercentage * xPercentage + yPercentage * yPercentage + zPercentage * zPercentage < 1.0D) {
+                            int blockId = result.getBlock(x, yIndex, z);
+                            if (blockId == Blocks.SOULSCHIST.id) {
+                                result.setBlock(x, yIndex, z, 0);
+                            }
+                        }
+                        yIndex--;
+                        y--;
+                    } while (true);
+                }
+            }
+        }
+    }
+
+    @Override
+    protected void doGeneration(World world, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, ChunkGeneratorResult result) {
+        int cavesToGenerate = rand.nextInt(rand.nextInt(rand.nextInt(100) + 1) + 1);
+        if (rand.nextInt(15) != 0) {
+            cavesToGenerate = 0;
+        }
+
+        final int yRange = maxY - minY;
+
+        for (int i = 0; i < cavesToGenerate; i++) {
+            double blockX = chunkX * Chunk.CHUNK_SIZE_X + rand.nextInt(Chunk.CHUNK_SIZE_X);
+            double blockY = minY + rand.nextInt(rand.nextInt(yRange - (ChunkSection.SECTION_SIZE_Y / 2)) + (ChunkSection.SECTION_SIZE_Y / 2));
+            double blockZ = chunkZ * Chunk.CHUNK_SIZE_Z + rand.nextInt(Chunk.CHUNK_SIZE_Z);
+
+            int numBranches = 1;
+            if (rand.nextInt(4) == 0) {
+                generateHubRoom(rand.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ);
+                numBranches += rand.nextInt(4);
+            }
+            for (int l1 = 0; l1 < numBranches; l1++) {
+                float yRot = rand.nextFloat() * MathHelper.PI * 2.0F; // 0 - 2Pi
+                float xRot = ((rand.nextFloat() - 0.5F) * 2.0F) / 8F; // -0.125 - 0.125
+                float initialRadius = rand.nextFloat() * 1.5f + rand.nextFloat(); // 0 - 3
+                generateCave(rand.nextLong(), baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, initialRadius, yRot, xRot, 0, 0, 1.0f);
+            }
+        }
+    }
+}
\ No newline at end of file
